/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Eclipseプラグイン [BlancoConstants]のプラグインクラス
 */
package blanco.plugin.constants;

import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * Eclipseプラグイン [BlancoConstants]のプラグインクラス。
 *
 * blancoConstantsプラグインのソースコード自動生成のための定義書です。<br>
 */
public class BlancoConstantsPlugin extends AbstractUIPlugin {
    /**
     * このプラグイン自身の共有インスタンス。
     */
    private static BlancoConstantsPlugin plugin;

    /**
     */
    public BlancoConstantsPlugin() {
        plugin = this;
    }

    /**
     * This method is called upon plug-in activation
     *
     * @param context プラグインバンドルのコンテキスト
     * @throws Exception
     */
    public void start(final BundleContext context) throws Exception {
        super.start(context);
    }

    /**
     * This method is called when the plug-in is stopped
     *
     * @param context プラグインバンドルのコンテキスト
     * @throws Exception
     */
    public void stop(final BundleContext context) throws Exception {
        super.stop(context);
        plugin = null;
    }

    /**
     * Returns the shared instance.
     *
     * @return プラグインの共有インスタンス。
     */
    public static BlancoConstantsPlugin getDefault() {
        return plugin;
    }

    /**
     * Returns an image descriptor for the image file at the given plug-in relative path.
     *
     * @param path イメージへのパス
     * @return 取得されたイメージデスクリプタ
     */
    public static ImageDescriptor getImageDescriptor(final String path) {
        return AbstractUIPlugin.imageDescriptorFromPlugin("blanco.plugin.constants", path);
    }

    /**
     * Eclipseに対してロギングを行います。
     *
     * @param ex ロギングの際に利用する例外オブジェクト
     */
    public static void log(final Throwable ex) {
        BlancoConstantsPlugin.getDefault().getLog().log(new Status(IStatus.WARNING, "blanco.plugin.constants", -1, ex.toString(), ex));
    }

    /**
     * プラグインのルートディレクトリを取得します。
     *
     * @return ルートディレクトリのURL これをgetPath()するとフルパスになります。
     * @throws IOException
     */
    public static URL getPluginRoot() throws IOException {
        final URL relativeURL = getDefault().getBundle().getEntry("/");
        final URL localURL = Platform.asLocalURL(relativeURL);
        return localURL;
    }
}
